<template>
  <div id="holder">
    <div class="cards">
      <div
        class="card"
        v-for="(card, index) in cards"
        :key="index"
        :class="{ flipped: card.flipped, found: card.found }"
        @click="flipCard(card)"
      >
        <div class="back"></div>
        <div class="front">
          <h2>{{ card.number }}</h2>
        </div>
      </div>
    </div>
    <div class="splash" v-if="showSplash">
      <div class="overlay"></div>
      <div class="content">
        <div class="title">You won!</div>
        <button class="newGame" @click="resetGame()">New game</button>
      </div>
    </div>
  </div>
</template>

<script>
import Vue from "vue";

let CardTypes = [
  { number: 1 },
  { number: 2 },
  { number: 3 },
  { number: 4 },
  { number: 5 },
  { number: 6 },
  { number: 7 },
  { number: 8 },
];

let shuffleCards = () => {
  let cards = [].concat(Vue._.cloneDeep(CardTypes), Vue._.cloneDeep(CardTypes));
  return Vue._.shuffle(cards);
};
export default {
  data() {
    return {
      showSplash: false,
      cards: [],
      started: false,
      startTime: 0,
      turns: 0,
      flipBackTimer: null,
      timer: null,

      clickTimer: null
    };
  },

  methods: {
    resetGame() {
      this.showSplash = false;
      let cards = shuffleCards();
      this.turns = 0;
      this.started = false;
      this.startTime = 0;

      this._.each(cards, (card) => {
        card.flipped = false;
        card.found = false;
      });

      this.cards = cards.sort(() => Math.random() - 0.5);
    },

    flippedCards() {
      return this._.filter(this.cards, (card) => card.flipped);
    },

    sameFlippedCard() {
      let flippedCards = this.flippedCards();
      if (flippedCards.length == 2) {
        if (flippedCards[0].number == flippedCards[1].number) return true;
      }
    },

    setCardFounds() {
      this._.each(this.cards, (card) => {
        if (card.flipped) card.found = true;
      });
    },

    checkAllFound() {
      let foundCards = this._.filter(this.cards, (card) => card.found);
      if (foundCards.length == this.cards.length) return true;
    },

    startGame() {
      this.started = true;
      this.startTime = this.$moment();

      this.timer = setInterval(() => {}, 1000);
    },

    finishGame() {
      this.started = false;
      clearInterval(this.timer);
      this.showSplash = true;
    },

    flipCard(card) {
      if (card.found || card.flipped) return;

      clearTimeout(this.clickTimer);
      this.clickTimer = setTimeout(() => {
        this.clearFlipBackTimer();
        this.clearFlips();
      }, 2000);

      if (!this.started) {
        this.startGame();
      }

      let flipCount = this.flippedCards().length;
      if (flipCount == 0) {
        card.flipped = !card.flipped;
      } else if (flipCount == 1) {
        card.flipped = !card.flipped;
        this.turns += 1;

        if (this.sameFlippedCard()) {
          // Match!
          this.flipBackTimer = setTimeout(() => {
            this.clearFlipBackTimer();
            this.setCardFounds();
            this.clearFlips();

            if (this.checkAllFound()) {
              this.finishGame();
            }
          }, 200);
        } else {
          // Wrong match
          this.flipBackTimer = setTimeout(() => {
            this.clearFlipBackTimer();
            this.clearFlips();
          }, 1000);
        }
      }
    },

    clearFlips() {
      this._.map(this.cards, (card) => (card.flipped = false));
    },

    clearFlipBackTimer() {
      clearTimeout(this.flipBackTimer);
      this.flipBackTimer = null;
    },
  },

  created() {
    this.resetGame();
  },
};
</script>

<style lang="scss" scoped>
.cards {
  display: grid;
  grid-template-columns: repeat(4, 1fr);
  grid-gap: 10px;
  .card {
    position: relative;
    display: inline-block;
    height: 200px;

    transition: all .35s ease 0s;
    transform-style: preserve-3d;
    position: relative;

    .front,
    .back {
      backface-visibility: hidden;
      position: absolute;
      left: 0;
      right: 0;
      top: 0;
      bottom: 0;
      width: 100%;
      height: 100%;
      background-color: White;
      transition: all .35s ease 0s;
    }

    .back {
      background-size: 90%;
      background: black;
      font-size: 12px;
      display: block;
      
    }

    .front {
      background-size: 90%;
      background-repeat: no-repeat;
      background-position: center;
      transform: rotateY(180deg);
      background: silver;
    }

    &.flipped,
    &.found {
      transform: rotateY(180deg);
      .front {
        z-index: 1;
      }
    }

    &.found {}
  }
}

.splash {
  position: absolute;
  left: 0;
  right: 0;
  top: 0;
  bottom: 0;

  .overlay {
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;

    background-color: rgba(#000, 0.6);
  }

  .content {
    position: absolute;
    left: 0;
    right: 0;
    top: 0;
    bottom: 0;

    width: 400px;
    height: 200px;

    margin: auto;
    text-align: center;

    background-color: rgba(#333, 0.9);

    padding: 1em;
  }
}
</style>
